/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.mentions.internal.util;

import com.liferay.mentions.matcher.BaseRegularExpressionMentionsMatcher;
import com.liferay.mentions.matcher.MentionsMatcher;
import com.liferay.mentions.matcher.MentionsMatcherUtil;

import org.osgi.service.component.annotations.Component;

/**
 * @author Adolfo Pérez
 */
@Component(
	immediate = true,
	property = {
		"model.class.name=*", "service.ranking:Integer=" + Integer.MIN_VALUE
	},
	service = MentionsMatcher.class
)
public class DefaultMentionsMatcher
	extends BaseRegularExpressionMentionsMatcher {

	@Override
	protected String getRegularExpression() {
		return _REGULAR_EXPRESSION;
	}

	private static final String _MENTIONS_REGULAR_EXPRESSION_TEMPLATE =
		"(?:\\s|^|\\]|>)(?:@|&#64;)(%s)(?=[<\\[\\s]|$)";

	private static final String _REGULAR_EXPRESSION;

	static {
		_REGULAR_EXPRESSION = String.format(
			_MENTIONS_REGULAR_EXPRESSION_TEMPLATE,
			MentionsMatcherUtil.getScreenNameRegularExpression());
	}

}